package com.streambase.contrib;

import java.util.List;

import com.streambase.sb.CompleteDataType;
import com.streambase.sb.DataType;
import com.streambase.sb.client.CustomFunctionResolver;

public class MoreLists {

	@CustomFunctionResolver("reduceListResolver")
	public static List<Long> reduceList(List<Long> lis){
		lis.remove(0);
		return lis;
	} 	
	
	@CustomFunctionResolver("TradeSizeResolver1")
	public static Long getTradeSize(List<Long> volume, int number){
		long average = 0;
		int bound = Math.min(number, volume.size());
		for (int i = 0; i < bound; i++)
			average += volume.get(i);
		return average;			
	}
	
	@CustomFunctionResolver("TradeSizeResolver2")
	public static List<Long> getRemainingSizes(List<Long> volume, int number){
		int bound = Math.min(number, volume.size());
		for (int i = 0; i < bound; i++)
			volume.remove(0);
		return volume;			
	}
	
	public static CompleteDataType reduceListResolver(CompleteDataType lis) {
		if (lis.getElementType() == CompleteDataType.forLong()) 
			return CompleteDataType.forList(CompleteDataType.forLong());
		return null;
	}

	public static CompleteDataType TradeSizeResolver1(CompleteDataType volume, CompleteDataType number) {
		if (volume.getElementType() == CompleteDataType.forLong() && number.getDataType() == DataType.INT) 
			return CompleteDataType.forLong();
		return null;
	}
	
	public static CompleteDataType TradeSizeResolver2(CompleteDataType volume, CompleteDataType number) {
		if (volume.getElementType() == CompleteDataType.forLong() && number.getDataType() == DataType.INT) 
			return CompleteDataType.forList(CompleteDataType.forLong());
		return null;
	}
}
